Unit SF47R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23C_p, UTSF12_p, SF49R_p;

function SF47R(X :Real; AN :Real; var IERR :Integer): Real;

implementation

function SF47R(X :Real; AN :Real; var IERR :Integer): Real;
var
I :Integer;
A,Z,W,X1,DGAM,B,W1,Z1,EPS1,R1 :Real;
const
ANMIN :Real = 0.5E0;
SYS089 :Real = 1.0E-6;
ITMAX :Integer = 20;
SYS059 :Real = 3.4E38;
XMIN :Real = 1.0E-12;
AMAX :Real = 40.0E0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
{  -  FORTRAN }
function FUNC(W: Real; A: Real; Z: Real): Real;
begin
Result := W*Exp(A*Ln(Z)-Z);
end;
{   - }
begin
{ Result -    SF47R  FORTRANe }
IERR := 0;
if ( AN >= ANMIN ) 
 then goto _1;
IERR := 65;
goto _10;
_1:
if ( X >= 0.E0 ) 
 then goto _2;
IERR := 66;
goto _10;
_2:
if ( X > XMIN ) 
 then goto _3;
Result := 0.0;
goto _11;
_3:
if ( AN <= AMAX ) 
 then goto _4;
X1 := Sqrt(X+X)-Sqrt(AN+AN-1.E0);
Result := SF49R(X1);
goto _11;
_4:
A := 0.5*AN;
Z := 0.5*X;
EPS1 := SYS089;
SF23C(A,0.E0,DGAM,R1,EPS1,1,IERR);
W := EMax1(0.5*A,13.E0);
if ( Z >= W ) 
 then goto _7;
W := 1.E0/(DGAM*A);
W1 := W;
for I:=1 to ITMAX do
 begin
  B := I;
  W1 := W1*Z/(A+B);
  if ( W1 <= SYS089*W ) 
   then goto _6;
  W := W+W1;
_5:
 end;
_6:
Result := FUNC(W,A,Z);
goto _11;
_7:
Z1 := 1.0/Z;
B := A-1.0;
W1 := B*Z1;
W := 1.0+W1;
for I:=2 to ITMAX do
 begin
  B := B-1.0;
  W1 := W1*B*Z1;
  if ( W1 <= SYS089*W ) 
   then goto _9;
  W := W+W1;
_8:
 end;
_9:
W := Z1*FUNC(W,A,Z);
Result := 1.0-W/DGAM;
goto _11;
_10:
UTSF12(IERR,47);
Result := SYS059;
_11:
exit;
end;

end.
